#  Copyright (c) PARRRATE T&V 2021. All rights reserved.

from typing import Awaitable

from bu4.asynchronous.easync import EAsync
from bu4.evaluation.constructs.evaluable import Evaluable

__all__ = ('EFuture',)


class EFuture(EAsync):
    def __init__(self, future: Awaitable):
        self.future = future
        super().__init__()

    async def _anext(self) -> Evaluable:
        return await self.future
